3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
18 unset COMMIT_AUTHOR_EMAIL
19 unset COMMIT_AUTHOR_NAME
21 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
23 GIT_AUTHOR_EMAIL=author@example.com
24 GIT_AUTHOR_NAME='A U Thor'
25 unset GIT_COMMITTER_DATE
26 GIT_COMMITTER_EMAIL=committer@example.com
27 GIT_COMMITTER_NAME='C O Mitter'
31 unset GIT_EXTERNAL_DIFF
33 unset GIT_OBJECT_DIRECTORY
34 unset SHA1_FILE_DIRECTORIES
35 unset SHA1_FILE_DIRECTORY
37 export GIT_MERGE_VERBOSITY
38 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
42 # Protect ourselves from common misconfiguration to export
43 # CDPATH into the environment
46 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
48 echo "* warning: Some tests will not work if GIT_TRACE" \
49 "is set as to trace on STDERR ! *"
50 echo "* warning: Please set GIT_TRACE to something" \
51 "other than 1, 2 or true ! *"
55 # Each test should start with something like this, after copyright notices:
57 # test_description='Description of this test...
58 # This test checks if command xyzzy does the right thing...
62 [ "x$TERM" != "xdumb" ] &&
64 tput bold >/dev/null 2>&1 &&
65 tput setaf 1 >/dev/null 2>&1 &&
66 tput sgr0 >/dev/null 2>&1 &&
72 -d|--d|--de|--deb|--debu|--debug)
74 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
76 -h|--h|--he|--hel|--help)
78 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
80 -q|--q|--qu|--qui|--quie|--quiet)
92 if test -n "$color"; then
95 error) tput bold; tput setaf 1;; # bold red
96 skip) tput bold; tput setaf 2;; # bold green
97 pass) tput setaf 2;; # green
98 info) tput setaf 3;; # brown
99 *) test -n "$quiet" && return;;
107 test -z "$1" && test -n "$quiet" && return
114 say_color error "error: $*"
123 test "${test_description}" != "" ||
124 error "Test script did not set test_description."
126 if test "$help" = "t"
128 echo "$test_description"
133 if test "$verbose" = "t"
137 exec 4>/dev/null 3>/dev/null
145 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
148 if test -z "${test_tick+set}"
152 test_tick=$(($test_tick + 60))
154 GIT_COMMITTER_DATE="$test_tick -0700"
155 GIT_AUTHOR_DATE="$test_tick -0700"
156 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
159 # You are not expected to call test_ok_ and test_failure_ directly, use
160 # the text_expect_* functions instead.
163 test_count=$(expr "$test_count" + 1)
164 say_color "" " ok $test_count: $@"
168 test_count=$(expr "$test_count" + 1)
169 test_failure=$(expr "$test_failure" + 1);
170 say_color error "FAIL $test_count: $1"
172 echo "$@" | sed -e 's/^/ /'
173 test "$immediate" = "" || { trap - exit; exit 1; }
176 test_known_broken_ok_ () {
177 test_count=$(expr "$test_count" + 1)
178 test_fixed=$(($test_fixed+1))
179 say_color "" " FIXED $test_count: $@"
182 test_known_broken_failure_ () {
183 test_count=$(expr "$test_count" + 1)
184 test_broken=$(($test_broken+1))
185 say_color skip " still broken $test_count: $@"
189 test "$debug" = "" || eval "$1"
199 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
200 this_test="$this_test.$(expr "$test_count" + 1)"
202 for skp in $GIT_SKIP_TESTS
211 say_color skip >&3 "skipping test: $@"
212 test_count=$(expr "$test_count" + 1)
213 say_color skip "skip $test_count: $1"
222 test_expect_failure () {
224 error "bug in the test script: not 2 parameters to test-expect-failure"
227 say >&3 "checking known breakage: $2"
229 if [ "$?" = 0 -a "$eval_ret" = 0 ]
231 test_known_broken_ok_ "$1"
233 test_known_broken_failure_ "$1"
239 test_expect_success () {
241 error "bug in the test script: not 2 parameters to test-expect-success"
244 say >&3 "expecting success: $2"
246 if [ "$?" = 0 -a "$eval_ret" = 0 ]
256 test_expect_code () {
258 error "bug in the test script: not 3 parameters to test-expect-code"
261 say >&3 "expecting exit code $1: $3"
263 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
273 # Most tests can use the created repository, but some may need to create more.
274 # Usage: test_create_repo <directory>
275 test_create_repo () {
277 error "bug in the test script: not 1 parameter to test-create-repo"
281 cd "$repo" || error "Cannot setup test environment"
282 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
283 error "cannot run git init -- have you built things yet?"
284 mv .git/hooks .git/hooks-disabled
291 if test "$test_fixed" != 0
293 say_color pass "fixed $test_fixed known breakage(s)"
295 if test "$test_broken" != 0
297 say_color error "still have $test_broken known breakage(s)"
298 msg="remaining $(($test_count-$test_broken)) test(s)"
300 msg="$test_count test(s)"
302 case "$test_failure" in
305 # cd .. && rm -fr trash
306 # but that means we forbid any tests that use their own
307 # subdirectory from calling test_done without coming back
308 # to where they started from.
309 # The Makefile provided will clean this test area so
310 # we will leave things as they are.
312 say_color pass "passed all $msg"
316 say_color error "failed $test_failure among $msg"
322 # Test the binaries we have just built. The tests are kept in
323 # t/ subdirectory and are run in trash subdirectory.
325 GIT_EXEC_PATH=$(pwd)/..
326 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
328 unset GIT_CONFIG_LOCAL
329 GIT_CONFIG_NOSYSTEM=1
330 GIT_CONFIG_NOGLOBAL=1
331 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
333 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
335 test -d ../templates/blt || {
336 error "You haven't built things yet, have you?"
339 if ! test -x ../test-chmtime; then
340 echo >&2 'You need to build test-chmtime:'
341 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
348 test_create_repo $test
351 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
352 for skp in $GIT_SKIP_TESTS
355 for skp in $GIT_SKIP_TESTS
364 say_color skip >&3 "skipping test $this_test altogether"
365 say_color skip "skip all tests in $this_test"